------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Rects;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Frames is

   type Shadow is
    (Plain,
     Raised,
     Sunken);
   pragma Convention (C, Shadow);
   for Shadow'Size use Interfaces.C.int'Size;
   for Shadow use
    (Plain =>     16#10#,
     Raised =>     16#20#,
     Sunken =>     16#30#);

   type Shape is
    (No_Frame,
     Box,
     Panel,
     Win_Panel,
     H_Line,
     V_Line,
     Styled_Panel);
   pragma Convention (C, Shape);
   for Shape'Size use Interfaces.C.int'Size;

   type Q_Frame is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Frame_Access is
     access all Q_Frame'Class;
   for Q_Frame_Access'Storage_Size use 0;

   type Q_Frame_Pointer is tagged;

   function Frame_Rect
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Rects.Q_Rect;

   function Frame_Shadow
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Frames.Shadow;

   function Frame_Shape
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Frames.Shape;

   function Frame_Width
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Q_Integer;

   function Line_Width
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Q_Integer;

   function Mid_Line_Width
    (Self : not null access constant Q_Frame'Class)
       return Qt4.Q_Integer;

   procedure Set_Frame_Rect
    (Self : not null access Q_Frame'Class;
     Rect : Qt4.Rects.Q_Rect);

   procedure Set_Frame_Shadow
    (Self : not null access Q_Frame'Class;
     Shadow : Qt4.Frames.Shadow);

   procedure Set_Frame_Shape
    (Self : not null access Q_Frame'Class;
     Shape : Qt4.Frames.Shape);

   procedure Set_Line_Width
    (Self : not null access Q_Frame'Class;
     Width : Qt4.Q_Integer);

   procedure Set_Mid_Line_Width
    (Self : not null access Q_Frame'Class;
     Width : Qt4.Q_Integer);

   type Style_Mask is
    (Shape_Mask,
     Shadow_Mask);
     pragma Convention (C, Style_Mask);
   for Style_Mask'Size use Interfaces.C.int'Size;
   for Style_Mask use
    (Shape_Mask  => 16#0000000F#,
     Shadow_Mask => 16#000000F0#);

   type Frame_Style is new Interfaces.C.int;

   function "+" (Left  : Frame_Style;
                 Right : Shadow)
     return Frame_Style;

   function "+" (Left  : Frame_Style;
                 Right : Shape)
     return Frame_Style;

   function "+" (Left  : Frame_Style;
                 Right : Style_Mask)
     return Frame_Style;

   function "+" (Left  : Shadow;
                 Right : Shape)
     return Frame_Style;

   function "+" (Left  : Shadow;
                 Right : Style_Mask)
     return Frame_Style;

   function "+" (Left  : Shape;
                 Right : Shadow)
     return Frame_Style;

   function "+" (Left  : Shape;
                 Right : Style_Mask)
     return Frame_Style;

   function "+" (Left  : Style_Mask;
                 Right : Shadow)
     return Frame_Style;

   function "+" (Left  : Style_Mask;
                 Right : Shape)
     return Frame_Style;

   procedure Set_Frame_Style
    (Self  : not null access Q_Frame'Class;
     Style : Frame_Style);

   package Q_Frame_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Frame, Q_Frame_Access);

   type Q_Frame_Pointer is
     new Q_Frame_Pointers.Q_Pointer with null record;

end Qt4.Frames;
